unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls, Buttons, Balloon, ComCtrls, TLHelp32,
  Menus, Registry, ShellAPI;

const
  WM_ICONTRAY = WM_USER + 1;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Shape1: TShape;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    Timer2: TTimer;
    BalloonControl1: TBalloonControl;
    ComboBox1: TComboBox;
    Panel1: TPanel;
    SpeedButton3: TSpeedButton;
    Panel2: TPanel;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    Shape2: TShape;
    XSpinEdit1: TSpinEdit;
    XSpinEdit2: TSpinEdit;
    XSpinEdit3: TSpinEdit;
    ListView1: TListView;
    PopupMenu1: TPopupMenu;
    Refresh1: TMenuItem;
    KillCheckedNow1: TMenuItem;
    PopupMenu2: TPopupMenu;
    Runonstartup1: TMenuItem;
    Removefromstartuprun1: TMenuItem;
    Exit1: TMenuItem;
    GoToSystemTray1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    PopupMenu3: TPopupMenu;
    Open1: TMenuItem;
    Quit1: TMenuItem;
    AddToRightClickMenu1: TMenuItem;
    RemoveFromRightClickMenu1: TMenuItem;
    Timer1: TTimer;
    N3: TMenuItem;
    ShutdownMow1: TMenuItem;
    N4: TMenuItem;
    About1: TMenuItem;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure KillCheckedNow1Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure DoKill;
    procedure Exit1Click(Sender: TObject);
    procedure Runonstartup1Click(Sender: TObject);
    procedure Removefromstartuprun1Click(Sender: TObject);
    procedure GoToSystemTray1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure AddRightClick;
    procedure RemRightClick;
    procedure AddToRightClickMenu1Click(Sender: TObject);
    procedure RemoveFromRightClickMenu1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure ShutdownMow1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
    TrayIconData: TNotifyIconData;
  public
    { Public declarations }
    procedure TrayMessage(var Msg: TMessage); message WM_ICONTRAY;
  end;

var
  Form1: TForm1;
  TH, TM, TS: Integer;
  XTH, XTM, XTS: Integer;
  PresentTime, CountTime, TotalTime, LeftTime: TDateTime;
  XPresentTime, XCountTime, XTotalTime, XLeftTime: TDateTime;
  ListItem: TListItem;

function SetSuspendState(hibernate, forcecritical, disablewakeevent: boolean):
  boolean; stdcall; external 'powrprof.dll' name 'SetSuspendState';

function IsHibernateAllowed: boolean; stdcall; external 'powrprof.dll' name
  'IsPwrHibernateAllowed';

function IsPwrSuspendAllowed: Boolean; stdcall; external 'powrprof.dll' name
  'IsPwrSuspendAllowed';

function IsPwrShutdownAllowed: Boolean; stdcall; external 'powrprof.dll' name
  'IsPwrShutdownAllowed';

implementation

{$R *.dfm}

///Hibernate Starts

procedure machine_hibernate;
begin
  if IsHibernateAllowed then
    SetSuspendState(true, false, false)
  else
    MessageDlg('System Hibernate not supported on this system.', mtWarning,
      [mbOK], 0);
end;
//Hibernate Ends

procedure DoAppToRun(RunName, AppName: string);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  with Reg do
  begin
    RootKey := HKEY_LOCAL_MACHINE;
    OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', True);
    WriteString(RunName, AppName);
    CloseKey;
    //Add to current user
   //RootKey := HKEY_CURRENT_USER;
   //OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', True);
   //WriteString(RunName, AppName);
   //CloseKey;

    Free;
  end;
end;

// Check if the application is in the registry...
// Prfen, ob Anwendung in der Registry vorhanden ist...

function IsAppInRun(xRootKey: HKEY; RunName: string): Boolean;
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  with Reg do
  begin
    RootKey := xRootKey;
    OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', False);
    Result := ValueExists(RunName);
    CloseKey;
    Free;
  end;
end;

// Remove the application from the registry...
// Anwendung aus der Registry entfernen...

procedure DelAppFromRun(xRootKey: HKEY; RunName: string);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  with Reg do
  begin
    RootKey := xRootKey;
    OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', True);
    if ValueExists(RunName) then
      DeleteValue(RunName);
    CloseKey;
    Free;
  end;
end;

procedure EnumProcess;
var
  MyHandle: THandle;
  Struct: TProcessEntry32;
begin
  Form1.ListView1.Clear;
  Form1.ListView1.Items.BeginUpdate;

  try
    MyHandle := CreateToolHelp32SnapShot(TH32CS_SNAPPROCESS, 0);
    Struct.dwSize := Sizeof(TProcessEntry32);
    if Process32First(MyHandle, Struct) then
    begin
      ListItem := Form1.ListView1.Items.Add;
      ListItem.Caption := Struct.szExeFile;
    end;

    while Process32Next(MyHandle, Struct) do
    begin
      ListItem := Form1.ListView1.Items.Add;
      ListItem.Caption := Struct.szExeFile;
    end;

  except on exception do
      ShowMessage('Error showing process list');
  end;

  Form1.ListView1.Items.EndUpdate;
  Form1.ListView1.AlphaSort;
  Form1.ListView1.Refresh;
  Application.ProcessMessages
end;

function KillTask(ExeFileName: string): Integer;
const
  PROCESS_TERMINATE = $0001;
var
  ContinueLoop: BOOL;
  FSnapshotHandle: THandle;
  FProcessEntry32: TProcessEntry32;
begin
  Result := 0;
  FSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  FProcessEntry32.dwSize := SizeOf(FProcessEntry32);
  ContinueLoop := Process32First(FSnapshotHandle, FProcessEntry32);

  while Integer(ContinueLoop) <> 0 do
  begin
    if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) =
      UpperCase(ExeFileName)) or (UpperCase(FProcessEntry32.szExeFile) =
      UpperCase(ExeFileName))) then
      Result := Integer(TerminateProcess(
        OpenProcess(PROCESS_TERMINATE,
        BOOL(0),
        FProcessEntry32.th32ProcessID),
        0));
    ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
  end;
  CloseHandle(FSnapshotHandle);
end;

function DoExitWindows(RebootParam: Longword): boolean;
var
  TTokenHd: THandle;
  TTokenPvg: TTokenPrivileges;
  cbtpPrevious: DWORD;
  rTTokenPvg: TTokenPrivileges;
  pcbtpPreviousRequired: DWORD;
  tpResult: boolean;
const
  cSE_SHUTDOWN_NAME = 'SeShutdownPrivilege';
begin
  if (Win32Platform = VER_PLATFORM_WIN32_NT) then
  begin
    tpResult := OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES
      or TOKEN_QUERY, TTokenHd);
    if tpResult then
    begin
      tpResult := LookupPrivilegeValue(nil, cSE_SHUTDOWN_NAME,
        TTokenPvg.Privileges[0].Luid);
      TTokenPvg.PrivilegeCount := 1;
      TTokenPvg.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
      cbtpPrevious := SizeOf(rTTokenPvg);
      pcbtpPreviousRequired := 0;
      if tpResult then
        Windows.AdjustTokenPrivileges(TTokenHd, false, TTokenPvg, cbtpPrevious,
          rTTokenPvg, pcbtpPreviousRequired);
    end;
  end;
  Result := ExitWindowsEx(RebootParam, 0);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if Timer2.Enabled then
    with BalloonControl1 do
    begin
      Control := SpinEdit3;
      Vertical := blnBottom;
      Horizontal := blnMiddle;
      Duration := 2;
      Text.Clear;
      Text.Add('Already running. Click on Disable to set new time again.');
      ShowControlBalloon;
    end;

  TH := SpinEdit1.Value;
  TM := SpinEdit2.Value;
  TS := SpinEdit3.Value;

  if (TH = 0) and (TM = 0) and (TS = 0) then
    if MessageDlg('Shutdown now?', mtCustom, mbOKCancel, 0) = mrOK then
      TS := 2
    else
      Exit;

  SpinEdit1.ReadOnly := True;
  SpinEdit2.ReadOnly := True;
  SpinEdit3.ReadOnly := True;

  (*
  SpinEdit1.Font.Color := clRed;
  SpinEdit2.Font.Color := clRed;
  SpinEdit3.Font.Color := clRed;
  *)
  PresentTime := Now;
  CountTime := Encodetime(TH, TM, TS, 0);
  TotalTime := PresentTime + CountTime;

  GroupBox1.SetFocus;
  Timer2.Enabled := True;
  Shape1.Visible := True;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Timer2.Enabled := False;

  SpinEdit1.ReadOnly := False;
  SpinEdit2.ReadOnly := False;
  SpinEdit3.ReadOnly := False;

  (*
  SpinEdit1.Font.Color := clWindow;
  SpinEdit2.Font.Color := clWindow;
  SpinEdit3.Font.Color := clWindow;
  *)

  SpinEdit1.Value := 0;
  SpinEdit2.Value := 0;
  SpinEdit3.Value := 0;

  Shape1.Visible := False;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
  Hour, Min, Sec, MSec: Word;
begin
  PresentTime := Now;
  LeftTime := TotalTime - PresentTime;

  DecodeTime(LeftTime, Hour, Min, Sec, MSec);

  SpinEdit1.Value := Hour;
  SpinEdit2.Value := Min;
  SpinEdit3.Value := Sec;

  if (Hour = 0) and (Min = 0) and (Sec = 0) then
  begin
    Form1.Caption := 'Time up';
    Timer2.Enabled := False;
    if ComboBox1.ItemIndex = 0 then
      DoExitWindows(EWX_SHUTDOWN or EWX_FORCE)
    else if ComboBox1.ItemIndex = 1 then
      DoExitWindows(EWX_REBOOT or EWX_FORCE)
    else if ComboBox1.ItemIndex = 2 then
      DoExitWindows(EWX_LOGOFF or EWX_FORCE)
    else if ComboBox1.ItemIndex = 3 then
      machine_hibernate;

    //Form1.Caption:= 'Shutdown';
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  form1.ClientHeight := Panel1.Top + Panel1.Height + 1;
  SpeedButton3.Align := alClient;
  ListItem := TListItem.Create(Form1.ListView1.Items);
  GoToSystemTray1.Click;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var
  lp: Integer;
begin
  if panel2.Visible then
    exit;
  Form1.ClientHeight := panel2.Top + panel2.Height + 1;
  panel2.Enabled := True;
  Panel2.Visible := True;

  EnumProcess;

end;

procedure TForm1.KillCheckedNow1Click(Sender: TObject);
begin
  DoKill;
end;

procedure TForm1.Refresh1Click(Sender: TObject);
begin
  EnumProcess;
end;

procedure TForm1.DoKill;
var
  i: Integer;
begin
  for i := (ListView1.Items.Count - 1) downto 0 do
    if ListView1.Items[i].Checked then
      KillTask(ListView1.Items[i].Caption);

  EnumProcess;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Runonstartup1Click(Sender: TObject);
begin
  DoAppToRun('Mumeet', Application.ExeName);
end;

procedure TForm1.Removefromstartuprun1Click(Sender: TObject);
begin
  if IsAppInRun(HKEY_LOCAL_MACHINE, 'Mumeet') then
    DelAppFromRun(HKEY_LOCAL_MACHINE, 'Mumeet');

  if IsAppInRun(HKEY_CURRENT_USER, 'Mumeet') then
    DelAppFromRun(HKEY_CURRENT_USER, 'Mumeet');

end;

procedure TForm1.GoToSystemTray1Click(Sender: TObject);
begin
  with TrayIconData do
  begin
    cbSize := SizeOf(TrayIconData);
    Wnd := Handle;
    uID := 0;
    uFlags := NIF_MESSAGE + NIF_ICON + NIF_TIP;
    uCallbackMessage := WM_ICONTRAY;
    hIcon := Application.Icon.Handle;
    StrPCopy(szTip, Application.Title);
  end;

  Shell_NotifyIcon(NIM_ADD, @TrayIconData);
  Form1.Visible := False;
end;

procedure TForm1.TrayMessage(var Msg: TMessage);
var
  TP: TPoint;
begin
  case Msg.lParam of
    WM_LBUTTONDOWN:
      begin
        Form1.Visible := True;
        //ShowMessage('Left button clicked - let''s SHOW the Form!');
        //MainForm.Show;
        //LabelPopuphideClick(nil);
      end;
    WM_RBUTTONDOWN:
      begin
        GetCursorPos(TP);
        PopupMenu3.Popup(TP.X, TP.Y);
        //ShowMessage('Right button clicked - let''s HIDE the Form!');
        //MainForm.Hide;
      end;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Shell_NotifyIcon(NIM_DELETE, @TrayIconData);
  ListItem.Free;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  if not Form1.Visible then
    Form1.Visible := True;

  Form1.BringToFront;
end;

procedure TForm1.Quit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.AddRightClick;
var
  Reg: TRegistry;
begin
  Reg := Tregistry.create;
  with Reg do
  begin
    RootKey := HKEY_CLASSES_ROOT;
    OpenKey('Directory\Background\shell', false);
    if not KeyExists('Mumeet') then
      CreateKey('Mumeet');
    CloseKey;
    OpenKey('Directory\Background\shell\Mumeet', False);
    WriteString('', 'Mumeet');
    if not KeyExists('command') then
      CreateKey('Command');
    Closekey;
    OpenKey('Directory\Background\shell\Mumeet\command', true);
    WriteString('', Application.ExeName);
    CloseKey;
  end
end;

procedure TForm1.RemRightClick;
begin
  //
end;

procedure TForm1.AddToRightClickMenu1Click(Sender: TObject);
begin
  AddRightClick;
end;

procedure TForm1.RemoveFromRightClickMenu1Click(Sender: TObject);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;

  Reg.RootKey := HKEY_CLASSES_ROOT;

  try
    if not Reg.OpenKey('Directory\Background\shell\Mumeet', False) then
      ShowMessage('Key not found.')
    else
    begin
      Reg.CloseKey;
      Reg.DeleteKey('Directory\Background\shell\Mumeet');
    end;
  finally
    Reg.Free;
  end;

end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  if Timer1.Enabled then
    with BalloonControl1 do
    begin
      Control := XSpinEdit3;
      Vertical := blnBottom;
      Horizontal := blnMiddle;
      Duration := 2;
      Text.Clear;
      Text.Add('Already running. Click on Disable to set new time again.');
      ShowControlBalloon;
    end;

  XTH := XSpinEdit1.Value;
  XTM := XSpinEdit2.Value;
  XTS := XSpinEdit3.Value;

  if (XTH = 0) and (XTM = 0) and (XTS = 0) then
    if MessageDlg('Terminate checked programs now?', mtCustom, mbOKCancel, 0) =
      mrOK then
      XTS := 2
    else
      Exit;

  XSpinEdit1.ReadOnly := True;
  XSpinEdit2.ReadOnly := True;
  XSpinEdit3.ReadOnly := True;

  XPresentTime := Now;
  XCountTime := Encodetime(XTH, XTM, XTS, 0);
  XTotalTime := XPresentTime + XCountTime;

  GroupBox2.SetFocus;
  Timer1.Enabled := True;
  Shape2.Visible := True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  Hour, Min, Sec, MSec: Word;
begin
  XPresentTime := Now;
  XLeftTime := XTotalTime - XPresentTime;

  DecodeTime(XLeftTime, Hour, Min, Sec, MSec);

  XSpinEdit1.Value := Hour;
  XSpinEdit2.Value := Min;
  XSpinEdit3.Value := Sec;

  if (Hour = 0) and (Min = 0) and (Sec = 0) then
  begin
    Timer1.Enabled := False;
    DoKill;
    Shape2.Visible := False;
  end;

end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  Timer1.Enabled := False;

  XSpinEdit1.ReadOnly := False;
  XSpinEdit2.ReadOnly := False;
  XSpinEdit3.ReadOnly := False;

  XSpinEdit1.Value := 0;
  XSpinEdit2.Value := 0;
  XSpinEdit3.Value := 0;

  Shape2.Visible := False;
end;

procedure TForm1.ShutdownMow1Click(Sender: TObject);
begin
  DoExitWindows(EWX_SHUTDOWN or EWX_FORCE);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  ShowMessage('' + #13 +
    'In the name of Allah the Merciful the Beneficent.' + #13 +
    'Peace be upon Muhammad.' + #13 +
    '' + #13 +
    'Mumeet Shut or Kill On Time v2.0' + #13 +
    'Freeware.' + #13 +
    '' + #13 +
    'Rabiul Hassan Khan.' + #13 +
    'mail: rabiul_prkp85@yahoo.com' + #13 +
    'Chittagong, Bangladesh.' + #13 +
    '');
end;

end.

